/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2009 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2014 Cores Co., Ltd. Japan
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: if_rx62nreg.h 108 2015-06-11 09:15:46Z coas-nagasima $
 */

#ifndef RX62NRegH
#define RX62NRegH

#include "t_stddef.h"

#define EDMAC_EDMR			((uint32_t *)0x000C0000)	/* EDMAC[hWX^ */
#define EDMAC_EDMR_SWR_BIT	0x00000001
#define EDMAC_EDMR_DE_BIT	0x00000040

#define EDMAC_EDTRR			((uint32_t *)0x000C0008)	/* EDMACMvWX^ */
#define EDMAC_EDTRR_TR		0x00000001

#define EDMAC_EDRRR			((uint32_t *)0x000C0010)	/* EDMACMvWX^ */
#define EDMAC_EDRRR_RR		0x00000001

#define EDMAC_TDLAR			((uint32_t *)0x000C0018)	/* MfBXNv^Xg擪AhXWX^ */
#define EDMAC_RDLAR			((uint32_t *)0x000C0020)	/* MfBXNv^Xg擪AhXWX^ */

#define EDMAC_EESR			((uint32_t *)0x000C0028)	/* ETHERC/EDMACXe[^XWX^ */
#define EDMAC_EESR_FROF		0x00010000
#define EDMAC_EESR_RDE		0x00020000
#define EDMAC_EESR_FR		0x00040000
#define EDMAC_EESR_TC		0x00200000
#define EDMAC_EESR_TWB		0x40000000

#define EDMAC_EESIPR		((uint32_t *)0x000C0030)	/* ETHERC/EDMACXe[^X荞݋WX^ */
#define EDMAC_EESIPR_RMAFIP	0x00000080
#define EDMAC_EESIPR_FROFIP	0x00010000
#define EDMAC_EESIPR_RDEIP	0x00020000
#define EDMAC_EESIPR_FRIP	0x00040000
#define EDMAC_EESIPR_TCIP	0x00200000
#define EDMAC_EESIPR_TWBIP	0x40000000

#define EDMAC_TRSCER		((uint32_t *)0x000C0038)	/* MXe[^XRs[wWX^ */
#define EDMAC_RMFCR			((uint32_t *)0x000C0040)	/* ~Xht[JE^WX^ */
#define EDMAC_TFTR			((uint32_t *)0x000C0048)	/* MFIFOlw背WX^ */
#define EDMAC_FDR			((uint32_t *)0x000C0050)	/* FIFOeʎw背WX^ */
#define EDMAC_RMCR			((uint32_t *)0x000C0058)	/* M䃌WX^ */
#define EDMAC_TFUCR			((uint32_t *)0x000C0064)	/* MFIFOA_JEg */
#define EDMAC_RFOCR			((uint32_t *)0x000C0068)	/* MFIFOI[ot[JEg */
#define EDMAC_IOSR			((uint32_t *)0x000C006C)	/* ʏo͐Mݒ背WX^ */
#define EDMAC_FCFTR			((uint32_t *)0x000C0070)	/* t[JnFIFOlݒ背WX^ */
#define EDMAC_RPADIR		((uint32_t *)0x000C0078)	/* Mf[^pfBO}ݒ背WX^ */
#define EDMAC_TRIMD			((uint32_t *)0x000C007C)	/* M荞ݐݒ背WX^ */
#define EDMAC_RBWAR			((uint32_t *)0x000C00C8)	/* Mobt@CgAhXWX^ */
#define EDMAC_RDFAR			((uint32_t *)0x000C00CC)	/* MfBXNv^tFb`AhXWX^ */
#define EDMAC_TBRAR			((uint32_t *)0x000C00D4)	/* Mobt@[hAhXWX^ */
#define EDMAC_TDFAR			((uint32_t *)0x000C00D8)	/* MfBXNv^tFb`AhXWX^ */

#define ETHERC_ECMR			((uint32_t *)0x000C0100)	/* ETHERC[hWX^ */
#define ETHERC_ECMR_PRM		0x00000001
#define ETHERC_ECMR_DM		0x00000002
#define ETHERC_ECMR_RTM		0x00000004
#define ETHERC_ECMR_TE		0x00000020
#define ETHERC_ECMR_RE		0x00000040

#define ETHERC_RFLR			((uint32_t *)0x000C0108)	/* Mt[WX^ */
#define ETHERC_ECSR			((uint32_t *)0x000C0110)	/* ETHERCXe[^XWX^ */
#define ETHERC_ECSR_LCHNG	0x00000004
#define ETHERC_ECSIPR		((uint32_t *)0x000C0118)	/* ETHERC荞݋WX^ */
#define ETHERC_ECSIPR_LCHNGIP	0x00000004
#define ETHERC_PIR			((uint32_t *)0x000C0120)	/* PHYC^tF[XWX^ */
#define ETHERC_PIR_MDC		0x00000001
#define ETHERC_PIR_MMD		0x00000002
#define ETHERC_PIR_MDO		0x00000004
#define ETHERC_PIR_MDI		0x00000008

#define ETHERC_PSR			((uint32_t *)0x000C0128)	/* PHYXe[^XWX^ */
#define ETHERC_PSR_LMON		0x00000001

#define ETHERC_RDMLR		((uint32_t *)0x000C0140)	/* JE^lݒ背WX^ */
#define ETHERC_IPGR			((uint32_t *)0x000C0150)	/* IPGݒ背WX^ */
#define ETHERC_APR			((uint32_t *)0x000C0154)	/* PAUSEt[ݒ背WX^ */
#define ETHERC_MPR			((uint32_t *)0x000C0158)	/* 蓮PAUSEt[ݒ背WX^ */
#define ETHERC_RFCF			((uint32_t *)0x000C0160)	/* MPAUSEt[JE^ */
#define ETHERC_TPAUSER		((uint32_t *)0x000C0164)	/* PAUSEt[đ񐔐ݒ背WX^ */
#define ETHERC_TPAUSECR		((uint32_t *)0x000C0168)	/* PAUSEt[đ񐔃JE^ */
#define ETHERC_BCFRR		((uint32_t *)0x000C016C)	/* Broadcastt[M񐔐ݒ背WX^ */
#define ETHERC_MAHR			((uint32_t *)0x000C01C0)	/* MACAhXʐݒ背WX^ */
#define ETHERC_MALR			((uint32_t *)0x000C01C8)	/* MACAhXʐݒ背WX^ */
#define ETHERC_TROCR		((uint32_t *)0x000C01D0)	/* MgCI[oJE^WX^ */
#define ETHERC_CDCR			((uint32_t *)0x000C01D4)	/* xՓˌoJE^WX^ */
#define ETHERC_LCCR			((uint32_t *)0x000C01D8)	/* LAJE^WX^ */
#define ETHERC_CNDCR		((uint32_t *)0x000C01DC)	/* LAoJE^WX^ */
#define ETHERC_CEFCR		((uint32_t *)0x000C01E4)	/* CRCG[t[MJE^WX^ */
#define ETHERC_FRECR		((uint32_t *)0x000C01E8)	/* t[MG[JE^WX^ */
#define ETHERC_TSFRCR		((uint32_t *)0x000C01EC)	/* 64oCgt[MJE^WX^ */
#define ETHERC_TLFRCR		((uint32_t *)0x000C01F0)	/* woCgt[MJE^WX^ */
#define ETHERC_RFCR			((uint32_t *)0x000C01F4)	/* [rbgt[MJE^WX^ */
#define ETHERC_MAFCR		((uint32_t *)0x000C01F8)	/* }`LXgAhXt[MJE^WX^ */

/* MfBXNv^ */
typedef struct t_rx62n_tx_desc {
	uint32_t	tfs : 26;
	uint32_t	twbi : 1;
	uint32_t	tfe : 1;
	uint32_t	tfp : 2;
	uint32_t	tdle : 1;
	uint32_t	tact : 1;
	uint32_t	: 16;
	uint32_t	tbl : 16;
	uint32_t	tba;
	uint32_t	binding;
} T_RX62N_TX_DESC;

/* MfBXNv^ */
typedef struct t_rx62n_rx_desc {
	uint32_t	rfs : 27;
	uint32_t	rfe : 1;
	uint32_t	rfp : 2;
	uint32_t	rdle : 1;
	uint32_t	ract : 1;
	uint32_t	rfl : 16;
	uint32_t	rbl : 16;
	uint32_t	rba;
	uint32_t	binding;
} T_RX62N_RX_DESC;

#endif /* RX62NRegH */
